<!DOCTYPE html>
<html>

<head>
  <title> Task 25.40 ... Tạo đơn hàng - xem chi tiết </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron">
    <div class="col-12">
      <div class="text-center mb-5"> <h1> Create Order </h1> </div>
        <div class="form-group row">
          <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
          <div class="col-sm-4">
            <select class="form-control" id="combo-select">
              <option value="0"> Chọn cỡ Combo (Combo size)</option>
              <option value="S"> Nhỏ</option>
              <option value="M"> Vừa</option>
              <option value="L"> Lớn</option>
            </select>
          </div>
          <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
          <div class="col-sm-4">
            <select class="form-control" id="select-drink">
              <option value="0">Chọn đồ uống</option>
            </select>
          </div>
        </div> 
        <div class="form-group row">
          <label class="col-sm-2 col-form-label" id="voucher-inp">Mã voucher</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Voucher ID (mã voucher)">
          </div>
          <label class="col-sm-2 col-form-label">Loại pizza</label>
          <div class="col-sm-4">
            <select class = "form-control" id="pizza-select">            <!-- select chưa có id, các option chưa có value-->
              <option value="0"> Chọn loại pizza </option>
              <option value = "Seafood" > Hải sản</option>
              <option value = "Hawaii"> Ha wai </option>
              <option value = "Bacon" > Thịt hun khói </option>
            </select>
          </div>        
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Họ và tên" id="ho-va-ten-inp"> 
          </div>
          <label for="" class="col-sm-2 col-form-label" >Email</label>
          <div class="col-sm-4">
            <input type="email" class="form-control" placeholder="Email" id="email-inp"> 
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Số điện thoại</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Số điện thoại" id="so-dien-thoai-inp">
          </div>
          <label class="col-sm-2 col-form-label">Địa chỉ</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Địa chỉ" id="dia-chi-inp"> 
          </div>
        </div>
        <div class="form-group">
          <label>Lời nhắn</label>
          <textarea class="form-control h-75" placeholder="Lời nhắn" id="loi-nhan-inp"></textarea>
        </div> 
        <div class="form-group">
          <button  class="btn btn-primary" onclick="onBtnCreateOrderClick()">Create Order</button>
          <button  class="btn btn-secondary" id="btn-order-data" onclick = "onBtnShowOrderDataClick()">Show Order Data in New Form</button>
        </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }
    
    function onBtnCreateOrderClick(){
      var vOrderObj = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVoucher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: ""
      };
      //b1: đọc dữ liệu
      dataRead(vOrderObj);
      console.log(vOrderObj);
      //b2: kiểm tra dữ liệu
      var vCheck = dataValidation(vOrderObj);
      if (vCheck){
        var vXmlHttpCreateOrder = new XMLHttpRequest();
        //b3: gọi Api
        goiApiCreateOrder (vOrderObj,vXmlHttpCreateOrder);

        //b4: xử lý hiển thị
        vXmlHttpCreateOrder.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) { // status 201 tao thanh cong
                  displayCreatedOrder(vXmlHttpCreateOrder);    
                }
            }
      }
    }
    //khai báo hàm Show Order Data in New Form
    function onBtnShowOrderDataClick(){
      var vBtnShowOrder = document.getElementById("btn-order-data");
      var vGetOrderCode = vBtnShowOrder.dataset.orderCode;
      console.log("Order code là: " + vGetOrderCode);
      //gọi form details
      const vDETAIL_FORM_URL = "orderDetail.html";
      var vUrlSiteToOpen = vDETAIL_FORM_URL + "?" +
      "orderCode=" +  vGetOrderCode;
      
      window.location.href = vUrlSiteToOpen;//mở trang web mới

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(vXhttp.responseText); // ghi response text ra console.log
            handleLoadDataToSelectDrink(vXhttp);
          }
        };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      //load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var vDrinkOptionElement = document.createElement("option");
        vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(vDrinkOptionElement);
      }
    }

    function dataRead(paramOrderObj){
      var vComboSelect = document.getElementById("combo-select");
      paramOrderObj.kichCo = vComboSelect.value;
      if (paramOrderObj.kichCo == "S"){
        paramOrderObj.duongKinh = 20;
        paramOrderObj.suon= 2;
        paramOrderObj.salad = 200;
        paramOrderObj.soLuongNuoc = 2;
        paramOrderObj.thanhTien = 150000;
      }
      else if (paramOrderObj.kichCo == "M"){
        paramOrderObj.duongKinh = 24;
        paramOrderObj.suon= 4;
        paramOrderObj.salad = 300;
        paramOrderObj.soLuongNuoc = 3;
        paramOrderObj.thanhTien = 200000;
      }
      else if (paramOrderObj.kichCo == "L"){
        paramOrderObj.duongKinh = 30;
        paramOrderObj.suon= 8;
        paramOrderObj.salad = 500;
        paramOrderObj.soLuongNuoc = 4;
        paramOrderObj.thanhTien = 250000;
      }
      paramOrderObj.loaiPizza = document.getElementById("pizza-select").value;
      paramOrderObj.idVoucher = document.getElementById("voucher-inp").value;
      paramOrderObj.idLoaiNuocUong = document.getElementById("select-drink").value;
      paramOrderObj.hoTen = document.getElementById("ho-va-ten-inp").value;
      paramOrderObj.email = document.getElementById("email-inp").value;
      paramOrderObj.soDienThoai = document.getElementById("so-dien-thoai-inp").value;
      paramOrderObj.diaChi = document.getElementById("dia-chi-inp").value;
      paramOrderObj.loiNhan = document.getElementById("loi-nhan-inp").value;
    }
  
    //khai báo hàm kiểm tra data 
    function dataValidation(paramOrderObj){
      if (paramOrderObj.kichCo == "0"||
      paramOrderObj.loaiPizza == "0" ||
      paramOrderObj.idLoaiNuocUong == "0"){
        alert("Please select order, pizza type, drink!");
        return false;
      }
      else if(paramOrderObj.hoTen == "" ||
      paramOrderObj.email == "" ||
      paramOrderObj.soDienThoai == "" ||
      paramOrderObj.diaChi == ""){
        alert ("Please input order information!");
        return false;
      }
      else return true;
    }
  
    //khai báo Api create order
    function goiApiCreateOrder(paramOrderObj,paramXmlHttp){
      const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
      paramXmlHttp.open("POST", vBASE_URL, true);
      paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
      paramXmlHttp.send(JSON.stringify(paramOrderObj));
    }
    //khai báo hàm hiển thị order đã tạo
    function displayCreatedOrder(paramXmlHttp){
      var vCreatedOrder = paramXmlHttp.responseText;
      console.log(vCreatedOrder);
      //yc3:
      var vOrderObj = JSON.parse(paramXmlHttp.responseText);
      //tạo biến để chứa order code
      var vOrderCode = vOrderObj.orderCode;
      //ghi order code vào data set của nút Show Order Data
      var vBtnShowOrder = document.getElementById("btn-order-data");
      vBtnShowOrder.setAttribute("data-order-code", vOrderCode);
    }
    
  </script>

</body>

</html>
